天天看点

【CodeForces - 687A NP-Hard Problem】 二分图染色

I - NP-Hard Problem

Recently, Pari and Arya did some research about NP-Hard problems and they found theminimum vertex cover problem very interesting.

Suppose the graph G is given. Subset A of its vertices is called a vertex cover of this graph, if for each edge uv there is at least one endpoint of it in this set, i.e. 

【CodeForces - 687A NP-Hard Problem】 二分图染色
 or 
【CodeForces - 687A NP-Hard Problem】 二分图染色

 (or both).

Pari and Arya have won a great undirected graph as an award in a team contest. Now they have to split it in two parts, but both of them want their parts of the graph to be a vertex cover.

They have agreed to give you their graph and you need to find two disjoint subsets of its vertices A and B, such that both A and B are vertex cover or claim it's impossible. Each vertex should be given to no more than one of the friends (or you can even keep it for yourself).

Input

The first line of the input contains two integers n and m (2 ≤ n ≤ 100 000, 1 ≤ m ≤ 100 000) — the number of vertices and the number of edges in the prize graph, respectively.

Each of the next m lines contains a pair of integers ui and vi (1  ≤  ui,  vi  ≤  n), denoting an undirected edge between ui and vi. It's guaranteed the graph won't contain any self-loops or multiple edges.

Output

If it's impossible to split the graph between Pari and Arya as they expect, print "-1" (without quotes).

If there are two disjoint sets of vertices, such that both sets are vertex cover, print their descriptions. Each description must contain two lines. The first line contains a single integer k denoting the number of vertices in that vertex cover, and the second line contains k integers — the indices of vertices. Note that because of m ≥ 1, vertex cover cannot be empty.

Example

Input
4 2
1 2
2 3
      
Output
1
2 
2
1 3 
      
Input
3 3
1 2
2 3
1 3
      
Output
-1
      

Note

In the first sample, you can give the vertex number 2 to Arya and vertices numbered1 and 3 to Pari and keep vertex number 4 for yourself (or give it someone, if you wish).

In the second sample, there is no way to satisfy both Pari and Arya.

题意:给出一个无向图,由<=n个点组成,给出m组数据,说明此两点之间存在一条边。现Pari和Arya想要把图分为两部分,但是他们都希望他们的图形部分含有顶点(如果对于每个边缘uv,在该集合中至少有一个端点或两个的点)。

分析:根据所给关系建图,因为点数可能<=n,所以用maxn记录最大点数,建好图后dfs给图染色,如果染色成功,遍历每个点记录颜色不同的点,染色失败则输出-1。

代码如下:

#include <set>
#include <map>
#include <queue>
#include <cmath>
#include <vector>
#include <cctype>
#include <cstdio>
#include <cstring>
#include <iostream>
#include <algorithm>
#define mod 835672545
#define INF 0x3f3f3f3f
#define LL long long
using namespace std;
const int MX = 1e5 + 5;
int n, m, tot;
int head[MX];
int color[MX];
int p1[MX], p2[MX];
struct node{
    int v, nxt;
}e[MX];
void init(){
    tot = 0;
    memset(head, -1, sizeof(head));
    memset(color, -1, sizeof(color));
}
void add(int u, int v){
    e[tot].v = v;
    e[tot].nxt = head[u];
    head[u] = tot++;
}
int dfs(int u, int c){
    color[u] = c;
    for(int i = head[u]; ~i; i = e[i].nxt){
        int v = e[i].v;
        if(color[v] != -1 && color[v] == color[u])   return 0;
        else if(color[v] == -1){
            if(!dfs(v, c^1)) return 0;
        }
    }
    return 1;
}
int main(){
    while(~scanf("%d%d", &n, &m)){
        init();
        int maxn = 0;
        int flag = 1;
        for(int i = 0; i < m; i++){
            int u, v;
            scanf("%d%d", &u, &v);
            add(u, v);
            add(v, u);
            maxn = max(maxn, max(u, v));
        }
        for(int i = 1; i <= maxn; i++){
            if(color[i] == -1){
                if(!dfs(i, 0)){
                    printf("-1\n");
                    flag = 0;
                    break;
                }
            }
        }
        if(!flag)    continue;
        int ans1 = 0, ans2 = 0;
        for(int i = 1; i <= maxn; i++){
            if(color[i] == 1)   p1[ans1++] = i;
            if(color[i] == 0)   p2[ans2++] = i;
        }
        printf("%d\n", ans1);
        for(int i = 0; i < ans1; i++){
            printf("%d", p1[i]);
            if(i < ans1-1){
                printf(" ");
            }
            else    printf("\n");
        }
        printf("%d\n", ans2);
        for(int i = 0; i < ans2; i++){
            printf("%d", p2[i]);
            if(i < ans2-1){
                printf(" ");
            }
            else    printf("\n");
        }
    }
    return 0;
}